Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py	(revision 12032)
@@ -36,9 +36,10 @@
 from waeup.ikoba.interfaces import (
     IObjectHistory, IUserAccount, IFileStoreNameChooser, IFileStoreHandler,
-    IIkobaUtils, registration_states_vocab, IExtFileStore,
+    IIkobaUtils, IExtFileStore,
     CREATED, REQUESTED, APPROVED)
 from waeup.ikoba.customers.export import EXPORTER_NAMES
 from waeup.ikoba.customers.interfaces import (
-    ICustomer, ICustomerNavigation, ICSVCustomerExporter)
+    ICustomer, ICustomerNavigation, ICSVCustomerExporter,
+    ICustomersUtils)
 from waeup.ikoba.customers.utils import generate_customer_id
 from waeup.ikoba.customers.documents import CustomerDocumentsContainer
@@ -126,7 +127,10 @@
     @property
     def translated_state(self):
-        state = registration_states_vocab.getTermByToken(
-            self.state).title
-        return state
+        try:
+            TRANSLATED_STATES = getUtility(ICustomersUtils).TRANSLATED_STATES
+            ts = TRANSLATED_STATES[self.state]
+            return ts
+        except KeyError:
+            return
 
     @property
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12032)
@@ -23,5 +23,5 @@
 from zope.component import getUtility
 from waeup.ikoba.interfaces import (
-    IExtFileStore, IFileStoreNameChooser, IIkobaUtils)
+    IExtFileStore, IFileStoreNameChooser)
 from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.customers.catalog import CustomersQuery
@@ -147,5 +147,5 @@
             ICustomerDocument,
             exclude_attribs=False,
-            omit=['is_editable']))) + (
+            omit=['is_editable', 'translated_state']))) + (
             'customer_id',)
 
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py	(revision 12032)
@@ -19,5 +19,6 @@
 """
 import grok
-from waeup.ikoba.interfaces import STARTED, APPROVED
+from waeup.ikoba.interfaces import MessageFactory as _
+from waeup.ikoba.interfaces import CREATED, STARTED, REQUESTED, APPROVED
 from waeup.ikoba.customers.interfaces import ICustomersUtils
 
@@ -41,2 +42,9 @@
 
     DOCMANAGE_STATES = (APPROVED,)
+
+    TRANSLATED_STATES = {
+        CREATED: _('created'),
+        STARTED: _('started'),
+        REQUESTED: _('requested'),
+        APPROVED: _('approved'),
+        }
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/document.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/document.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/document.py	(revision 12032)
@@ -32,5 +32,6 @@
 from waeup.ikoba.utils.helpers import attrs_to_fields, get_current_principal
 from waeup.ikoba.utils.logger import Logger
-from waeup.ikoba.documents.interfaces import IDocument, IDocument
+from waeup.ikoba.documents.interfaces import (
+    IDocument, IDocument, IDocumentsUtils)
 from waeup.ikoba.documents.utils import generate_document_id
 
@@ -52,10 +53,4 @@
         return
 
-    #def __init__(self):
-    #    super(Document, self).__init__()
-    #    timestamp = ("%d" % int(time()*10000))[1:]
-    #    self.document_id = "d%s" % timestamp
-     #   return
-
     def __init__(self):
         super(Document, self).__init__()
@@ -76,4 +71,13 @@
         state = IWorkflowState(self).getState()
         return state
+
+    @property
+    def translated_state(self):
+        try:
+            TRANSLATED_STATES = getUtility(IDocumentsUtils).TRANSLATED_STATES
+            ts = TRANSLATED_STATES[self.state]
+            return ts
+        except KeyError:
+            return
 
 Document = attrs_to_fields(Document)
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/interfaces.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/interfaces.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/interfaces.py	(revision 12032)
@@ -19,7 +19,8 @@
 from zope import schema
 from waeup.ikoba.interfaces import (
-    IIkobaObject, SimpleIkobaVocabulary, 
+    IIkobaObject,
     ContextualDictSourceFactoryBase)
 from waeup.ikoba.interfaces import MessageFactory as _
+
 
 class DocumentTypeSource(ContextualDictSourceFactoryBase):
@@ -46,4 +47,6 @@
     history = Attribute('Object history, a list of messages')
     state = Attribute('Returns the verification state of a document')
+    translated_state = Attribute(
+        'Returns a translated, more verbose verification state of a document')
 
     title = schema.TextLine(
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/utils.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/utils.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/utils.py	(revision 12032)
@@ -19,6 +19,10 @@
 """
 import grok
+from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.documents.workflow import CREATED
 from waeup.ikoba.documents.interfaces import IDocumentsUtils
+from waeup.ikoba.documents.workflow import (
+    CREATED, SUBMITTED,
+    VERIFIED, REJECTED, OUTDATED)
 
 
@@ -34,2 +38,10 @@
 
     DOCMANAGE_STATES = (CREATED,)
+
+    TRANSLATED_STATES = {
+        CREATED: _('document created'),
+        SUBMITTED: _('document submitted'),
+        VERIFIED: _('document verified'),
+        REJECTED: _('document rejected'),
+        OUTDATED:_('document outdated')
+        }
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/workflow.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/workflow.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/documents/workflow.py	(revision 12032)
@@ -24,5 +24,6 @@
 from hurry.workflow.interfaces import IWorkflowState, IWorkflowTransitionEvent
 from waeup.ikoba.interfaces import (
-    IObjectHistory, IIkobaWorkflowInfo, IIkobaUtils)
+    IObjectHistory, IIkobaWorkflowInfo,
+    SimpleIkobaVocabulary)
 from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.workflow import IkobaWorkflow, IkobaWorkflowInfo
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/interfaces.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/interfaces.py	(revision 12031)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/interfaces.py	(revision 12032)
@@ -83,11 +83,4 @@
 application_sessions_vocab = SimpleIkobaVocabulary(*application_sessions())
 
-registration_states_vocab = SimpleIkobaVocabulary(
-    (_('created'), CREATED),
-    (_('started'), STARTED),
-    (_('requested'), REQUESTED),
-    (_('approved'), APPROVED),
-    )
-
 class ContextualDictSourceFactoryBase(SmartBasicContextualSourceFactory):
     """A base for contextual sources based on IkobaUtils dicts.